function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import AuthService from '../AuthService';
import firebase from 'firebase/app';

var f_firebase_auth = Symbol("Internal field firebase.auth.Auth");

var FirebaseAuth = function (_AuthService) {
    _inherits(FirebaseAuth, _AuthService);

    /**
     * @param {*} firebaseAuth Initialized firebase instance
     */
    function FirebaseAuth(firebaseAuth) {
        _classCallCheck(this, FirebaseAuth);

        var _this = _possibleConstructorReturn(this, _AuthService.call(this));

        _this.onAuthStateChanged = function (callback) {
            return _this[f_firebase_auth].onAuthStateChanged(callback);
        };

        _this.signOut = function () {
            return _this[f_firebase_auth].signOut();
        };

        _this.getUser = function () {
            return _this[f_firebase_auth].currentUser;
        };

        if (!firebase.auth) throw new Error('Import firebase/auth first');
        if (!(firebaseAuth instanceof firebase.auth.Auth)) throw new Error('Argument firebaseAuth is not an instance of firebase.auth.Auth.' + ' Use firebase.auth() to have one');
        _this[f_firebase_auth] = firebaseAuth;
        return _this;
    }

    return FirebaseAuth;
}(AuthService);

export { FirebaseAuth as default };