import _regeneratorRuntime from "babel-runtime/regenerator";

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import Persistence from "../Persistence";

var InMemoryPersistence = function (_Persistence) {
    _inherits(InMemoryPersistence, _Persistence);

    function InMemoryPersistence() {
        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            initialDB = _ref.initialDB,
            logger = _ref.logger;

        _classCallCheck(this, InMemoryPersistence);

        var _this = _possibleConstructorReturn(this, _Persistence.call(this));

        _this.logger = logger || console;
        _this.db = initialDB || {};
        return _this;
    }

    InMemoryPersistence.prototype.at = function at(context) {
        this.db[context] = this.db[context] || {};
        var clone = new InMemoryPersistence({ initialDB: this.db[context], logger: this.logger });
        return clone;
    };

    InMemoryPersistence.prototype.save = function save(value, at) {
        this.db[at] = value;
        this.logger.log("InMemory : Saved " + JSON.stringify(value) + " at " + at);
        return Promise.resolve(at);
    };

    InMemoryPersistence.prototype.read = function () {
        var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(ref) {
            return _regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            if (!(this.db[ref] === undefined)) {
                                _context.next = 2;
                                break;
                            }

                            return _context.abrupt("return", null);

                        case 2:
                            return _context.abrupt("return", this.db[ref]);

                        case 3:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function read(_x2) {
            return _ref2.apply(this, arguments);
        }

        return read;
    }();

    InMemoryPersistence.prototype.delete = function _delete(ref) {
        delete this.db[ref];
        this.logger.log("InMemory : Deleted value at " + ref);
        return Promise.resolve(ref);
    };

    return InMemoryPersistence;
}(Persistence);

export default InMemoryPersistence;