import _regeneratorRuntime from "babel-runtime/regenerator";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import Persistence from "../Persistence";

var LS = window.localStorage;

var LocalStoragePersistence = function (_Persistence) {
    _inherits(LocalStoragePersistence, _Persistence);

    function LocalStoragePersistence() {
        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
            path = _ref.path;

        _classCallCheck(this, LocalStoragePersistence);

        var _this = _possibleConstructorReturn(this, _Persistence.call(this));

        _this.path = path || "persistence";
        _this.context = null;
        return _this;
    }

    LocalStoragePersistence.prototype.at = function at(context) {
        var clone = new LocalStoragePersistence({ path: this.path });
        clone.context = context;
        return clone;
    };

    LocalStoragePersistence.prototype.loadLS = function loadLS() {
        return JSON.parse(LS.getItem(this.path) || '{}');
    };

    LocalStoragePersistence.prototype.save = function () {
        var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(value, at) {
            var _extends2, _extends3;

            var previous;
            return _regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            previous = this.loadLS();

                            LS.setItem(this.path, JSON.stringify(_extends({}, previous, (_extends3 = {}, _extends3[this.context] = _extends({}, previous[this.context] || {}, (_extends2 = {}, _extends2[at] = value, _extends2)), _extends3))));
                            return _context.abrupt("return", at);

                        case 3:
                        case "end":
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function save(_x2, _x3) {
            return _ref2.apply(this, arguments);
        }

        return save;
    }();

    LocalStoragePersistence.prototype.read = function () {
        var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(ref) {
            var previous;
            return _regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            previous = this.loadLS();

                            if (!(previous[this.context] === undefined || previous[this.context][ref] === undefined)) {
                                _context2.next = 3;
                                break;
                            }

                            return _context2.abrupt("return", null);

                        case 3:
                            return _context2.abrupt("return", previous[this.context][ref]);

                        case 4:
                        case "end":
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function read(_x4) {
            return _ref3.apply(this, arguments);
        }

        return read;
    }();

    LocalStoragePersistence.prototype.delete = function _delete(ref) {
        return this.save(undefined, ref);
    };

    return LocalStoragePersistence;
}(Persistence);

export default LocalStoragePersistence;