import { Type } from "./Type";
import { makePredicate, isEmpty } from "./predicates";
import ValidationError from "./ValidationError";

var isBool = makePredicate(function (value) {
  return typeof value === 'boolean';
});

var boolean = new Type().extendWithValidators(function (value) {
  return isEmpty.or(isBool)(value) ? [] : [new ValidationError("numbani:validations.boolean.invalidType", { value: value })];
});

export default boolean;