import { Type } from "./Type";
import { makePredicate, isEmpty } from "./predicates";
import ValidationError from "./ValidationError";

var isDate = makePredicate(function (value) {
  return value instanceof Date;
});

var date = new Type().extendWithValidators(function (value) {
  return isEmpty.or(isDate)(value) ? [] : [new ValidationError("numbani:validations.date.invalidType", { value: value })];
});

export default date;