/**
 * 
 * @param {(value : any) => boolean} test
 */
export var makePredicate = function makePredicate(test) {

    var predicate = function predicate(value) {
        return test(value);
    };

    /**
     * 
     * @param {(value : any) => boolean} anotherTest 
     */
    predicate.and = function (anotherTest) {
        return makePredicate(function (value) {
            return predicate(value) && anotherTest(value);
        });
    };

    /**
     * 
     * @param {(value : any) => boolean} anotherTest 
     */
    predicate.or = function (anotherTest) {
        return makePredicate(function (value) {
            return predicate(value) || anotherTest(value);
        });
    };

    return predicate;
};

export var isEmpty = makePredicate(function (value) {
    return value === null || value === undefined;
});