function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { Button } from 'reactstrap';
import PropTypes from 'prop-types';
import { injectEntityContext } from '../model/Entity';

var SaveButtonBase = function (_Component) {
    _inherits(SaveButtonBase, _Component);

    function SaveButtonBase() {
        _classCallCheck(this, SaveButtonBase);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    SaveButtonBase.prototype.render = function render() {
        var _props = this.props,
            ec = _props.entityContext,
            requireEdit = _props.requireEdit;

        return React.createElement(
            Button,
            {
                disabled: !ec.editedValue && requireEdit || ec.isSaving || !ec.isValid, onClick: ec.save,
                color: 'primary'
            },
            this.props.children
        );
    };

    return SaveButtonBase;
}(Component);

var SaveButton = injectEntityContext(SaveButtonBase);

SaveButton.propTypes = {
    children: PropTypes.node,
    requireEdit: PropTypes.bool
};

export default SaveButton;