function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { injectEntityContext } from '../model/Entity';
import { Alert } from 'reactstrap';

var SavingErrorBase = function (_Component) {
    _inherits(SavingErrorBase, _Component);

    function SavingErrorBase() {
        _classCallCheck(this, SavingErrorBase);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    SavingErrorBase.prototype.render = function render() {
        var eC = this.props.entityContext;
        return !eC.isSaving && eC.savingError ? React.createElement(
            Alert,
            { color: 'danger' },
            typeof this.props.children === 'function' ? this.props.children(eC.savingError) : this.props.children || eC.savingError.message || eC.savingError.toString()
        ) : null;
    };

    return SavingErrorBase;
}(Component);

var SavingError = injectEntityContext(SavingErrorBase, 'entityContext');

SavingError.propTypes = {
    /**
     * Either a React element to display or a function that take as parameter
     * the error and returns the message to display or nothing, in this case
     * the component will try do display the error anyway.
     */
    children: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
};

export default SavingError;