function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Table as BTable } from 'reactstrap';
import Entity, { injectEntityContext } from '../model/Entity';
import Attribute from './Attribute';

var accessValue = function accessValue(value, accessor) {
    return typeof accessor === 'function' ? accessor(value) : value[accessor];
};

var BaseTable = function (_Component) {
    _inherits(BaseTable, _Component);

    function BaseTable() {
        _classCallCheck(this, BaseTable);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    BaseTable.prototype.render = function render() {
        var _props = this.props,
            ec = _props.entityContext,
            columns = _props.columns,
            index = _props.index,
            placeholder = _props.placeholder,
            others = _objectWithoutProperties(_props, ['entityContext', 'columns', 'index', 'placeholder']);

        return ec.loadedValues && ec.loadedValues.length > 0 ? React.createElement(
            BTable,
            others,
            React.createElement(
                'thead',
                null,
                React.createElement(
                    'tr',
                    null,
                    columns.map(function (column, i) {
                        return React.createElement(
                            'th',
                            { key: i },
                            column.header
                        );
                    })
                )
            ),
            React.createElement(
                'tbody',
                null,
                ec.loadedValues.map(function (value, i) {
                    return React.createElement(
                        'tr',
                        { key: index ? value[index] : i },
                        React.createElement(
                            Entity,
                            { repo: ec.repo, defaultValue: value },
                            columns.map(function (column, i) {
                                return React.createElement(
                                    'td',
                                    { key: i },
                                    typeof column.cell === "function" ? column.cell(value) : React.createElement(Attribute, { name: column.cell })
                                );
                            })
                        )
                    );
                })
            )
        ) : placeholder || null;
    };

    return BaseTable;
}(Component);

var Table = injectEntityContext(BaseTable);

Table.propTypes = {
    children: PropTypes.node,
    columns: PropTypes.arrayOf(PropTypes.shape({
        header: PropTypes.node.isRequired,
        cell: PropTypes.oneOfType([PropTypes.string, PropTypes.func]).isRequired
    })).isRequired,
    placeholder: PropTypes.node,
    index: PropTypes.string,
    size: PropTypes.string,
    bordered: PropTypes.bool,
    borderless: PropTypes.bool,
    striped: PropTypes.bool,
    dark: PropTypes.bool,
    hover: PropTypes.bool,
    responsive: PropTypes.bool
};

export default Table;