function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';

var ELEMENT_ID = "firebaseui-auth-container";
/**
 * This component is just a react wrapper around firebaseui web auth componnent
 * 
 * @class Login
 * @extends {Component}
 */

var Login = function (_Component) {
    _inherits(Login, _Component);

    function Login(props) {
        _classCallCheck(this, Login);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props));

        var firebaseui = _this.props.firebaseui;
        _this.ui = firebaseui.auth.AuthUI.getInstance() || new firebaseui.auth.AuthUI(_this.props.firebaseAuth);
        return _this;
    }

    Login.prototype.componentDidMount = function componentDidMount() {
        this.ui.start('#' + ELEMENT_ID, this.props.uiConfig);
    };

    Login.prototype.render = function render() {
        return React.createElement('div', { id: ELEMENT_ID });
    };

    return Login;
}(Component);

Login.propTypes = {
    /**
     * An instance of firebaseui.
     */
    firebaseui: PropTypes.object.isRequired,
    /**
     * An instance of firebase.auth.Auth;
     * After importing firebase and firebase.auth you can get one by calling firebase.auth()
     */
    firebaseAuth: PropTypes.object.isRequired,
    /** 
     *  FirebaseUI config object. More information here : {@link https://github.com/firebase/firebaseui-web#configuration}
     */
    uiConfig: PropTypes.object.isRequired
};
export default Login;