'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Allow access to user login state,
 * logout user, etc...
 * 
 * @export
 * @class AuthService
 */
var AuthService = function () {
    function AuthService() {
        _classCallCheck(this, AuthService);
    }

    /**
     * Get the actually connected user or
     * null if the user is not connected
     * 
     * @memberof AuthService
     */
    AuthService.prototype.getUser = function getUser() {
        throw new Error('Not implemented');
    };

    /**
     * Called when there is a change in auth state. The callback should not expect a param.
     * @param {function} callback 
     * @memberof AuthService
     * @return {function} A function to unsubscribe from this
     */


    AuthService.prototype.onAuthStateChanged = function onAuthStateChanged(callback) {
        throw new Error('Not implemented');
    };

    /**
     * Helper for user state
     * 
     * @returns {boolean}
     * @memberof AuthService
     */


    AuthService.prototype.userIsConnected = function userIsConnected() {
        return this.getUser() !== null;
    };
    /**
     * 
     * @returns {Promise}
     * @memberof AuthService
     */


    AuthService.prototype.signOut = function signOut() {
        throw new Error('Not implemented');
    };

    return AuthService;
}();

exports.default = AuthService;
module.exports = exports['default'];