"use strict";

exports.__esModule = true;
exports.Type = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _ValidationError = require("./ValidationError");

var _ValidationError2 = _interopRequireDefault(_ValidationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 
 * 
 * @export
 * @class Type
 */
// FIXME: Implement to string (and name)
var Type = exports.Type = function () {

    /**
     * 
     * 
     * @param {any} value 
     * @returns {Array.<ValidationError>}
     * @memberof Type
     */
    function Type() {
        _classCallCheck(this, Type);

        this.info = {};
    }
    /**
     *
     * Allow an instance of a more generic type to add aditionnal information that could be 
     * used by UI library to customize how the type is displayed
     * @param {String} name
     * @param {*} value
     * @memberof Type
     */


    Type.prototype.addInfo = function addInfo(name, value) {
        this.info[name] = value;
    };

    /**
     *
     * Allow an instance of a more generic type to add aditionnal information that could be 
     * used by UI library to customize how the type is displayed
     * @param {String} name
     * @returns
     * @memberof Type
     */


    Type.prototype.getInfo = function getInfo(name) {
        return this.info[name];
    };
    /**
     *
     *
     * @param {*} value
     * @returns {Array.<ValidationError>}
     * @memberof Type
     */


    Type.prototype.getValidationErrors = function getValidationErrors(value) {
        return [];
    };

    Type.prototype.accepts = function accepts(value) {
        return this.getValidationErrors(value).length === 0;
    };
    /**
     * Allow to build a new type by extending an existing one
     *
     * @param {*} validators
     * @returns {Type}
     * @memberof Type
     */


    Type.prototype.extendWithValidators = function extendWithValidators() {
        for (var _len = arguments.length, validators = Array(_len), _key = 0; _key < _len; _key++) {
            validators[_key] = arguments[_key];
        }

        var newType = Object.create(this);
        var that = this;

        newType.info = _extends({}, this.info);
        newType.getValidationErrors = function (value) {
            var errors = that.getValidationErrors(value);
            for (var _iterator = validators, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
                var _ref;

                if (_isArray) {
                    if (_i >= _iterator.length) break;
                    _ref = _iterator[_i++];
                } else {
                    _i = _iterator.next();
                    if (_i.done) break;
                    _ref = _i.value;
                }

                var validator = _ref;

                errors.push.apply(errors, validator(value));
            }
            return errors;
        };

        return newType;
    };

    Type.prototype.doExtends = function doExtends(otherType) {
        return otherType === this || otherType.isPrototypeOf(this);
    };

    Type.prototype.required = function required() {
        return this.extendWithValidators(function (value) {
            return value !== null && value !== undefined ? [] : [new _ValidationError2.default("numbani:validations.required", { value: value })];
        });
    };

    return Type;
}();