"use strict";

exports.__esModule = true;

var _Type = require("./Type");

var _predicates = require("./predicates");

var _ValidationError = require("./ValidationError");

var _ValidationError2 = _interopRequireDefault(_ValidationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isBool = (0, _predicates.makePredicate)(function (value) {
  return typeof value === 'boolean';
});

var boolean = new _Type.Type().extendWithValidators(function (value) {
  return _predicates.isEmpty.or(isBool)(value) ? [] : [new _ValidationError2.default("numbani:validations.boolean.invalidType", { value: value })];
});

exports.default = boolean;
module.exports = exports["default"];