"use strict";

exports.__esModule = true;

var _Type = require("./Type");

var _predicates = require("./predicates");

var _ValidationError = require("./ValidationError");

var _ValidationError2 = _interopRequireDefault(_ValidationError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isDate = (0, _predicates.makePredicate)(function (value) {
  return value instanceof Date;
});

var date = new _Type.Type().extendWithValidators(function (value) {
  return _predicates.isEmpty.or(isDate)(value) ? [] : [new _ValidationError2.default("numbani:validations.date.invalidType", { value: value })];
});

exports.default = date;
module.exports = exports["default"];