'use strict';

exports.__esModule = true;
exports.CarView = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _EntityManagerBuilder = require('../model/EntityManagerBuilder');

var _EntityManagerBuilder2 = _interopRequireDefault(_EntityManagerBuilder);

var _InMemory = require('../model/persistence/provider/InMemory');

var _InMemory2 = _interopRequireDefault(_InMemory);

var _EntitySchemaBuilder = require('../model/schema/EntitySchemaBuilder');

var _EntitySchemaBuilder2 = _interopRequireDefault(_EntitySchemaBuilder);

var _types = require('../model/schema/types');

var _types2 = _interopRequireDefault(_types);

var _bootstrap = require('./lib/bootstrap4');

var _bootstrap2 = _interopRequireDefault(_bootstrap);

var _ = require('.');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var entityManager = new _EntityManagerBuilder2.default().withPersistenceProvider(new _InMemory2.default({ initialDB: { cars: { mine: { brand: "Toyota" } } } })).build();

var carSchema = new _EntitySchemaBuilder2.default().addAttribute("brand", _types2.default.String.required().min(1).max(255))
//  .addAttribute("color", types.Enum.required().oneOf("red", "blue","green","black"))
.build();

var carsRepo = entityManager.register("cars", { schema: carSchema }); // <<<<< Here we have our EntityRepo

var CarView = exports.CarView = (0, _2.default)(_bootstrap2.default).forRepo(carsRepo); //<<<<< And then we build the EntityView

describe("EntityView.one", function () {

    it('Allow simple attribute interpolation', function () {
        var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
            CarView.one,
            { value: { brand: 'Toyota' } },
            _react2.default.createElement(CarView.fields.brand, null)
        ));

        (0, _expect2.default)(wrapper.text()).toBe('Toyota');
    });
});