'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Entity = require('../model/Entity');

var _reactstrap = require('reactstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LoadingErrorBase = function (_Component) {
    _inherits(LoadingErrorBase, _Component);

    function LoadingErrorBase() {
        _classCallCheck(this, LoadingErrorBase);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    LoadingErrorBase.prototype.render = function render() {
        var eC = this.props.entityContext;
        return !eC.isLoading && eC.loadingError ? _react2.default.createElement(
            _reactstrap.Alert,
            { color: 'danger' },
            typeof this.props.children === 'function' ? this.props.children(eC.loadingError) : this.props.children || eC.loadingError.message || eC.loadingError.toString()
        ) : null;
    };

    return LoadingErrorBase;
}(_react.Component);

var LoadingError = (0, _Entity.injectEntityContext)(LoadingErrorBase, 'entityContext');

LoadingError.propTypes = {
    /**
     * Either a React element to display or a function that take as parameter
     * the error and returns the message to display or nothing, in this case
     * the component will try do display the error anyway.
     */
    children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func])
};

exports.default = LoadingError;
module.exports = exports['default'];