'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactstrap = require('reactstrap');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Entity = require('../model/Entity');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SaveButtonBase = function (_Component) {
    _inherits(SaveButtonBase, _Component);

    function SaveButtonBase() {
        _classCallCheck(this, SaveButtonBase);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    SaveButtonBase.prototype.render = function render() {
        var _props = this.props,
            ec = _props.entityContext,
            requireEdit = _props.requireEdit;

        return _react2.default.createElement(
            _reactstrap.Button,
            {
                disabled: !ec.editedValue && requireEdit || ec.isSaving || !ec.isValid, onClick: ec.save,
                color: 'primary'
            },
            this.props.children
        );
    };

    return SaveButtonBase;
}(_react.Component);

var SaveButton = (0, _Entity.injectEntityContext)(SaveButtonBase);

SaveButton.propTypes = {
    children: _propTypes2.default.node,
    requireEdit: _propTypes2.default.bool
};

exports.default = SaveButton;
module.exports = exports['default'];