'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactstrap = require('reactstrap');

var _Entity = require('../model/Entity');

var _Entity2 = _interopRequireDefault(_Entity);

var _Attribute = require('./Attribute');

var _Attribute2 = _interopRequireDefault(_Attribute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var accessValue = function accessValue(value, accessor) {
    return typeof accessor === 'function' ? accessor(value) : value[accessor];
};

var BaseTable = function (_Component) {
    _inherits(BaseTable, _Component);

    function BaseTable() {
        _classCallCheck(this, BaseTable);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    BaseTable.prototype.render = function render() {
        var _props = this.props,
            ec = _props.entityContext,
            columns = _props.columns,
            index = _props.index,
            placeholder = _props.placeholder,
            others = _objectWithoutProperties(_props, ['entityContext', 'columns', 'index', 'placeholder']);

        return ec.loadedValues && ec.loadedValues.length > 0 ? _react2.default.createElement(
            _reactstrap.Table,
            others,
            _react2.default.createElement(
                'thead',
                null,
                _react2.default.createElement(
                    'tr',
                    null,
                    columns.map(function (column, i) {
                        return _react2.default.createElement(
                            'th',
                            { key: i },
                            column.header
                        );
                    })
                )
            ),
            _react2.default.createElement(
                'tbody',
                null,
                ec.loadedValues.map(function (value, i) {
                    return _react2.default.createElement(
                        'tr',
                        { key: index ? value[index] : i },
                        _react2.default.createElement(
                            _Entity2.default,
                            { repo: ec.repo, defaultValue: value },
                            columns.map(function (column, i) {
                                return _react2.default.createElement(
                                    'td',
                                    { key: i },
                                    typeof column.cell === "function" ? column.cell(value) : _react2.default.createElement(_Attribute2.default, { name: column.cell })
                                );
                            })
                        )
                    );
                })
            )
        ) : placeholder || null;
    };

    return BaseTable;
}(_react.Component);

var Table = (0, _Entity.injectEntityContext)(BaseTable);

Table.propTypes = {
    children: _propTypes2.default.node,
    columns: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        header: _propTypes2.default.node.isRequired,
        cell: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]).isRequired
    })).isRequired,
    placeholder: _propTypes2.default.node,
    index: _propTypes2.default.string,
    size: _propTypes2.default.string,
    bordered: _propTypes2.default.bool,
    borderless: _propTypes2.default.bool,
    striped: _propTypes2.default.bool,
    dark: _propTypes2.default.bool,
    hover: _propTypes2.default.bool,
    responsive: _propTypes2.default.bool
};

exports.default = Table;
module.exports = exports['default'];